/***************************************************************************
*
*	File name	: t8_api.h
*	Function	: APIs for T8
*	Revision	:
*		08/01/2007	Nariai		First revision
*
****************************************************************************/
#ifndef	__T8_API_H__
#define	__T8_API_H__

#ifdef	__cplusplus
extern "C" {
#endif

// T8 Ch. No
#define	T8_CH_0				0
#define	T8_CH_1				1
#define	T8_CH_2				2
#define	T8_CH_3				3

// Define for devide PCLK
#define	T8_PCLK_1			0x00
#define	T8_PCLK_2			0x01
#define	T8_PCLK_4			0x02
#define	T8_PCLK_8			0x03
#define	T8_PCLK_16			0x04
#define	T8_PCLK_32			0x05
#define	T8_PCLK_64			0x06
#define	T8_PCLK_128			0x07
#define	T8_PCLK_256			0x08
#define	T8_PCLK_512			0x09
#define	T8_PCLK_1024		0x0A
#define	T8_PCLK_2048		0x0B
#define	T8_PCLK_4096		0x0C


// T8 configuration
typedef struct {
	unsigned short		ReloadData;
	unsigned char		PclkDiv;
	void				(*intFunc)(void);
} T_T8_CFG;



// T8 APIs
extern void T8Init(unsigned char chNo, T_T8_CFG *pConfig);
extern void T8Start(unsigned char chNo);
extern void T8Stop(unsigned char chNo);

extern void T8Ch0IntProc(void);
extern void T8Ch1IntProc(void);
extern void T8Ch2IntProc(void);
extern void T8Ch3IntProc(void);

#ifdef __cplusplus
}
#endif

#endif	// __T8_API_H__

