# Make file generated by Gnu17 Plug-in for Eclipse
# This file should be placed directly under the project folder

# macro definitions for target file
TARGET= t8

# macro definitions for tools
TOOL_DIR= C:/EPSON/GNU17
CC= $(TOOL_DIR)/xgcc
AS= $(TOOL_DIR)/xgcc
AS_CC= $(TOOL_DIR)/as
LD= $(TOOL_DIR)/ld
RM= $(TOOL_DIR)/rm
SED= $(TOOL_DIR)/sed
CP= $(TOOL_DIR)/cp
CC_KFILT= $(TOOL_DIR)/xgcc_filt
OBJDUMP= $(TOOL_DIR)/objdump

# macro definitions for tool flags
CFLAGS= -B$(TOOL_DIR)/ -gstabs -S   -O1 -I$(TOOL_DIR)/include -Iflashc_drv -Icmu_drv -Igpio_drv -Iheader -Isramc_drv -Iitc_drv -It8_drv -fno-builtin 
ASFLAGS= -B$(TOOL_DIR)/ -c -xassembler-with-cpp -Wa,--gstabs  
ASFLAGS_CC=  
LDFLAGS=  -Map t8.map -N -T t8_gnu17IDE.lds  
EXTFLAGS= -Wa,-mc17_ext -Wa,$(TARGET).dump -Wa,$(TARGET).map
EXTFLAGS_CC= -mc17_ext $(TARGET).dump $(TARGET).map
OBJDUMPFLAGS= -t


# macro definitions for object files
OBJS= boot.o \
      inthdlr.o \
      main.o \
      vector.o \
      flashc_drv/flashc_drv.o \
      cmu_drv/cmu_drv.o \
      gpio_drv/gpio_drv.o \
      sramc_drv/sramc_drv.o \
      itc_drv/itc_drv.o \
      t8_drv/t8_drv.o \
      
# macro definitions for library files
OBJLDS= $(TOOL_DIR)/lib/24bit/libstdio.a \
        $(TOOL_DIR)/lib/24bit/libc.a \
        $(TOOL_DIR)/lib/24bit/libgcc.a \
        $(TOOL_DIR)/lib/24bit/libc.a \
        
# macro definitions for assembly files generated from c source files
CEXTTEMPS= boot.ext0 \
      inthdlr.ext0 \
      main.ext0 \
      vector.ext0 \
      flashc_drv/flashc_drv.ext0 \
      cmu_drv/cmu_drv.ext0 \
      gpio_drv/gpio_drv.ext0 \
      sramc_drv/sramc_drv.ext0 \
      itc_drv/itc_drv.ext0 \
      t8_drv/t8_drv.ext0 \
      

# macro definitions for original assembly files
ASMEXTTEMPS=                                                             

# macro definitions for dependency files
DEPS= $(OBJS:%.o=%.d)
SED_PTN= 's/[[:space:]]\([a-zA-Z]\)\:/ \/cygdrive\/\1/g'
SED_PTN2= 's/^\($(subst .,\.,$(@F))\)\:/$(subst /,\/,$(@))\:/g'

# macro definitions for creating dependency files
DEPCMD_CC= @$(CC_KFILT) -M -MG $(CFLAGS) $< | $(SED) -e $(SED_PTN) | $(SED) -e $(SED_PTN2) >$(@:%.o=%.d)
DEPCMD_AS= @$(AS) -M -MG $(ASFLAGS) $< | $(SED) -e $(SED_PTN) | $(SED) -e $(SED_PTN2) >$(@:%.o=%.d)

# targets and dependencies
.PHONY : all clean

all : $(TARGET).elf

$(TARGET).elf : $(OBJS) t8_gnu17IDE.mak t8_gnu17IDE.lds
# 1pass linking
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(OBJLDS) 2>lderr 
	@if [ -s lderr ]; then \
		cmd /c "type lderr" \
		&& $(RM) -f $(TARGET).elf \
		&& exit 1; \
	else $(RM) -f lderr ; \
	fi
	$(OBJDUMP) $(OBJDUMPFLAGS) $@ > $(TARGET).dump 
	$(RM) -f $(TARGET).elf 
# save 1pass object files
	@if [ -e obj1pass ]; then \
		cmd /c "rd /s /q obj1pass" ; \
	fi
	cmd /c "md obj1pass"
	-cmd /c "md obj1pass\flashc_drv"
	-cmd /c "md obj1pass\cmu_drv"
	-cmd /c "md obj1pass\gpio_drv"
	-cmd /c "md obj1pass\sramc_drv"
	-cmd /c "md obj1pass\itc_drv"
	-cmd /c "md obj1pass\t8_drv"
	for NAME in $(OBJS) ; do \
		$(CP) -pf $$NAME obj1pass/$$NAME ; done \
	&& $(RM) -f $(OBJS)
# 2pass for assembly files
	for NAME in $(basename $(ASMEXTTEMPS))  ; do \
		$(AS) $(ASFLAGS) $(EXTFLAGS) -o $$NAME.o $$NAME.s ; done
# 2pass for c files
	for NAME in $(basename $(CEXTTEMPS))  ; do \
		$(AS_CC) $(ASFLAGS_CC) $(EXTFLAGS_CC) -o $$NAME.o $$NAME.ext0 ; done
	$(RM) -f $(TARGET).map 
# 2pass linking
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(OBJLDS) 
# restore 1pass object files
	$(RM) -f $(OBJS) \
	&& \
	for NAME in $(OBJS) ; do \
		$(CP) -pf obj1pass/$$NAME $$NAME ; done \
	&& cmd /c "rd /s /q obj1pass"

## boot.c
boot.o : boot.c boot.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## inthdlr.c
inthdlr.o : inthdlr.c inthdlr.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## main.c
main.o : main.c main.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## vector.c
vector.o : vector.c vector.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## flashc_drv/flashc_drv.c
flashc_drv/flashc_drv.o : flashc_drv/flashc_drv.c flashc_drv/flashc_drv.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## cmu_drv/cmu_drv.c
cmu_drv/cmu_drv.o : cmu_drv/cmu_drv.c cmu_drv/cmu_drv.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## gpio_drv/gpio_drv.c
gpio_drv/gpio_drv.o : gpio_drv/gpio_drv.c gpio_drv/gpio_drv.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## sramc_drv/sramc_drv.c
sramc_drv/sramc_drv.o : sramc_drv/sramc_drv.c sramc_drv/sramc_drv.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## itc_drv/itc_drv.c
itc_drv/itc_drv.o : itc_drv/itc_drv.c itc_drv/itc_drv.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## t8_drv/t8_drv.c
t8_drv/t8_drv.o : t8_drv/t8_drv.c t8_drv/t8_drv.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)


# dependecies for assembled c source files
$(CEXTTEMPS) : $(CEXTTEMPS:%.ext0=%.c)

# include dependency files
-include $(DEPS)

# clean files
clean :
	$(RM) -f $(OBJS) $(TARGET).elf $(TARGET).map $(DEPS) $(CEXTTEMPS) $(TARGET).dump lderr 
	@if [ -e obj1pass ]; then \
		cmd /c "rd /s /q obj1pass" ; \
	fi
